
------------------------------------------------------------------ FADER . LUA ----------------------------------------------------------------------------
------------------------------------------------ EIN - und AUSBLENDEN der verschiedenen Gamestates --------------------------------------------------------

fader = class:new()

function fader:init()

	self.State = "in"
	self.Alpha = 255
	self.Speed = 200
	self.Target = ""
 
	-- SET COLOR MODE FOR FADE
	lg.setColorMode("replace")

	-- Change 'the colors of fade' :)
	self.r = 0
	self.g = 0
	self.b = 0
	
	-- Wait time

end

function fader:update(dt)


	-- FADE OUT
	if self.State == "out" and self.State ~= "in" then

			if self.Alpha < 255 then
				self.Alpha = self.Alpha + self.Speed * dt
			end
			
				if self.Alpha > 255 then 
					self.Alpha = 255	
				end
					
	end

	-- FADE IN
	if self.State == "in" and self.State ~= "out" then

			if self.Alpha > 0 then
				self.Alpha = self.Alpha - self.Speed * dt
			end
			
				if self.Alpha < 0 then 
					self.Alpha = 0	
				end
	end
	
	-- DEFINE THE READY STATES
	if self.Alpha == 0 or self.Alpha == 255 then self.State = "ready" end		
	
	if self.State == "ready" and switch and self.Target ~= "exit" then 
		gamestate.switch(self.Target)
		self.State = "in"
		self.Target = ""
		switch = false
	elseif  self.State == "ready" and switch and self.Target == "exit" then
		le.push( 'quit' )
	end
	
	
end

function fader:draw()

	if self.Alpha ~= nil then
	
			lg.setColor(self.r, self.g, self.b, self.Alpha)
			lg.rectangle("fill", 0, 0, width, height)
			lg.setColorMode("modulate")
					
	end
	
end

function fadeTo(target)

	fader.State = "out"
	switch = true
	fader.Target = target
	
end
