-- gameover lua
require 'lua/stars'

gameover = gamestate:new()


function gameover:init()
		
	
		
end


function gameover:enter()

	self:init()
	stars:init()

	button:init()
	button:new( 2, "Back", width / 2 - 32, height - 96)

end


function gameover:leave()

	fader.r, fader.g, fader.b = 0, 0, 0
	fader.speed = 200

end


function gameover:update( dt )

	button:update( dt )
	stars:update( dt )

end


function gameover:draw()
	
	stars:draw()
	
	lg.setColor( 255, 255, 255 )
	lg.printf( "Game Over", width / 2 - 100, height / 2 - font:getHeight()- 20, 200, "center" )
	lg.printf( "You remembered "..combine.counter.." dreams.", width / 2 - 100, height / 2 - font:getHeight(), 200, "center" )
	button:draw()

end


function gameover:keypressed( key )

	if key == "escape" then 
		fadeTo( menu )
	end

end


function gameover:mousepressed( x, y, b )

	if b == "l" then
	
		if button.table[1].sel then fadeTo( menu ) end
		onClick:play()
	end

end